Subject: bug#34249: closed (Re: [bug#34249] [PATCH] guix package: Avoid spinner at end of output.)

From: [email-masked] (GNU bug Tracking System)
Date: Wed, 06 Feb 2019 13:17:03 +0000

Your bug report

#34249: [PATCH] guix package: Avoid spinner at end of output.

which was filed against the guix-patches package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
34249: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=34249
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: [bug#34249] [PATCH] guix package: Avoid spinner at end of output.
From: Christopher Baines <[email-masked]>
To: Ludovic Courtès <[email-masked]>
Cc: [email-masked], [email-masked]
Date: Wed, 06 Feb 2019 13:16:23 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

Ludovic Courtès <[email-masked]> writes:

> Danny Milosavljevic <[email-masked]> skribis:
>
>> Hi Christopher,
>>> diff --git a/guix/scripts/package.scm b/guix/scripts/package.scm
>>> index a633d2ee6d..4db0e72e9b 100644
>>> --- a/guix/scripts/package.scm
>>> +++ b/guix/scripts/package.scm
>>> @@ -159,6 +159,7 @@ hooks\" run when building the profile."
>>>                 (switch-symlinks profile (basename name))
>>>                 (unless (string=? profile %current-profile)
>>>                   (register-gc-root store name))
>>> +               (display "\r") ; erase the spinner
>>
>> In order to actually erase it, might want to do (display "\r\x1b[K") instead.
>
> And to do that, you can use (erase-current-line port).
>
> Though actually I think this should be done in ‘print-build-event’ in
> (guix status).  Probably something like the patch below, but I haven’t
> been able to quickly reproduce the initial problem.
>
> Could you give it a spin (ah ha!) and report back?
>
> If it doesn’t solve the issue, we should strace the thing to see why it
> keeps spinning after everything is “done” basically.
>
> Thanks,
> Ludo’.
>
> diff --git a/guix/status.scm b/guix/status.scm
> index e3375816c5..7a330525b0 100644
> --- a/guix/status.scm
> +++ b/guix/status.scm
> @@ -465,8 +465,14 @@ addition to build events."
>              (_
>               (spin! port))))))
>
> -  (unless print-log?
> -    (display "\r" port))                          ;erase the spinner
> +  (define erase-current-line*
> +    (if (isatty?* port)
> +        (lambda (port)
> +          (erase-current-line port)
> +          (force-output port))
> +        (const #t)))
> +
> +  (erase-current-line* port)                      ;clear the spinner
>    (match event
>      (('build-started drv . _)
>       (let ((properties (derivation-properties

I've tried out the change you pushed here [1], and it looks good to me
:) I can't see anything odd in the output now.

1: https://git.savannah.gnu.org/cgit/guix.git/commit/?id=7473bce207af846312d5167a398f5f20bbf3e896

Subject: [PATCH] guix package: Avoid spinner at end of output.
From: Christopher Baines <[email-masked]>
To: [email-masked]
Date: Tue, 29 Jan 2019 19:50:31 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

Often guix package will report something like the following when performing
operations, for example:

  guix package -i hello
  ...
  building /gnu/store/wiwqmbi66gcr27dac3qqgrc8imyp1344-profile.drv...
  -117 packages in profile

Now there aren't -117 packages in this profile, it's just the spinner running
in to the output from Guix package. I'm not sure if this is a proper solution
for this issue, but it does work.

* guix/scripts/package.scm (build-and-use-profile): Erase the spinner before
output.
---
 guix/scripts/package.scm | 1 +
 1 file changed, 1 insertion(+)

diff --git a/guix/scripts/package.scm b/guix/scripts/package.scm
index a633d2ee6d..4db0e72e9b 100644
--- a/guix/scripts/package.scm
+++ b/guix/scripts/package.scm
@@ -159,6 +159,7 @@ hooks\" run when building the profile."
                (switch-symlinks profile (basename name))
                (unless (string=? profile %current-profile)
                  (register-gc-root store name))
+               (display "\r") ; erase the spinner
                (format #t (N_ "~a package in profile~%"
                               "~a packages in profile~%"
                               count)
-- 
2.20.1